<?php
/**
 *
 * Auther: heyu
 * DateTime: 2020-01-08 14:45
 *
 */

namespace kwy\aliPayOpenApi\auth;


use kwy\aliPayOpenApi\lib\ApiRequest;

class AppAuthToken extends ApiRequest
{

    const GRANT_TYPE_CODE='authorization_code';
    const GRANT_TYPE_TOKEN='refresh_token';


    /**
     * 获取授权码
     * @author heyu 2020-01-08 17:49
     * @param string $grant_type  AppAuthToken::GRANT_TYPE_CODE|AppAuthToken::GRANT_TYPE_TOKEN
     * @param string $code  当grant_type为code时  必填
     * @param string $refresh_token  当grant_type 为refresh时必填
     * @return array 多token列表数组
     * @throws \Exception 异常 auth_code不存在等
     */
    public function getAppAuthToken($grant_type,$code,$refresh_token=""){
        $method='alipay.open.auth.token.app';

        $param=[
            'grant_type'=>$grant_type,
        ];
        if ($grant_type==self::GRANT_TYPE_CODE){
            $param['code']=$code;
        }else{
            $param['refresh_token']=$refresh_token;
        }
        $result = $this->call($method,$param);
        if ($result['alipay_open_auth_token_app_response']['code']=='10000'){
            return $result['alipay_open_auth_token_app_response']['tokens'];
        }else{
            if (!empty($result['alipay_open_auth_token_app_response']['sub_msg'])){
                throw new \Exception($result['alipay_open_auth_token_app_response']['sub_msg']);
            }
            throw new \Exception($result['alipay_open_auth_token_app_response']['msg']);
        }
    }
}