<?php
/**
 *
 * Auther: heyu
 * DateTime: 2019-12-27 20:20
 *
 */

namespace kwy\aliPayOpenApi\pay;


use kwy\aliPayOpenApi\lib\ApiRequest;

class Trade extends ApiRequest
{

    /**
     * @author heyu 2019-12-27 20:37
     * @param MicroPayParam $microPayParam
     * @return string
     */
    public function pay($microPayParam){
        $method='alipay.trade.pay';

        $result = $this->call($method,$microPayParam->toArray());
        //var_dump($this->getHttp()->getLastRequestLog());

        return $result;
    }

    /**
     * 根据支付单号查询交易
     * @author heyu 2020-01-06 19:13
     * @param string $out_trade_no
     * @return string
     */
    public function query($out_trade_no){
        $method='alipay.trade.query';
        $result = $this->call($method,['out_trade_no'=>$out_trade_no,]);
        return $result;
    }

    /**
     * 退款
     * @author heyu 2020-01-06 19:13
     * @param string $out_trade_no 付款流水号
     * @param string $refund_amount 退款金额 单位元
     * @param string $out_request_no 退款单号
     * @return string
     */
    public function refund($out_trade_no,$refund_amount,$out_request_no){
        $method='alipay.trade.refund';
        $result = $this->call($method,[
            'out_trade_no'=>$out_trade_no,
            'refund_amount'=>$refund_amount,
            'out_request_no'=>$out_request_no,
        ]);
        return $result;
    }
}